"""
Silique (https://www.silique.fr)
Copyright (C) 2024-2025

This program is free software: you can redistribute it and/or modify it
under the terms of the GNU Lesser General Public License as published by the
Free Software Foundation, either version 3 of the License, or (at your
option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
details.

You should have received a copy of the GNU Lesser General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
"""

from pathlib import Path

from .i18n import _


def get_rougail_config(
    *,
    backward_compatibility=True,
) -> dict:
    options = f"""
display:
  description: {_('Display variables and values')}
  help: {_('Find all the variables and their values in your configuration (structural and user datas). Additional informations are available, such as the default value, the location where the value is loaded, etc.')}
  disabled:
    jinja: |-
      {{% if step.output is propertyerror or step.output != 'display' %}}
        true
      {{% else %}}
        false
      {{% endif %}}
    return_type: boolean
    description: {_('if display is not set in "step.output"')}

  show_secrets: false  # {_('Show secrets instead of obscuring them')}

  mandatory:
    description: {_('test mandatories variables before display in display')}
    type: boolean
    default:
      jinja: |-
        {{% if cli.read_write is defined and cli.read_write == true %}}
          false
        {{% else %}}
          true
        {{% endif %}}
      description: {_('do not test if "cli.read_write" is true')}

  max_width:
    description: {_("Maximum number of characters per line")}
    help: {_('null means unlimited')}
    type: integer
    mandatory: false
    params:
      min_integer: 50
"""
    return {
        "name": "display",
        "process": "output",
        "options": options,
        "level": 40,
    }


__all__ = ("get_rougail_config",)
